## spirv-llvm-translator 8.0.0

=== test/CMakeLists.txt ===
llvm_canonicalize_cmake_booleans(SKIP_SPIRV_DEBUG_INFO_TESTS)

# required by lit.site.cfg.py.in
get_target_property(LLVM_SPIRV_DIR llvm-spirv BINARY_DIR)
set(LLVM_SPIRV_TEST_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
configure_lit_site_cfg(
  ${CMAKE_CURRENT_SOURCE_DIR}/lit.site.cfg.py.in
  ${CMAKE_CURRENT_BINARY_DIR}/lit.site.cfg.py
  MAIN_CONFIG
    ${CMAKE_CURRENT_SOURCE_DIR}/lit.cfg.py
)

if(NOT BUILD_EXTERNAL)
  set(LLVM_SPIRV_TEST_DEPS
    FileCheck
    count
    llvm-as
    llvm-dis
    not
  )
  if(NOT SKIP_SPIRV_DEBUG_INFO_TESTS)
    list(APPEND LLVM_SPIRV_TEST_DEPS
      llc
      llvm-dwarfdump
      llvm-objdump
      llvm-readobj
    )
  endif(NOT SKIP_SPIRV_DEBUG_INFO_TESTS)
endif(NOT BUILD_EXTERNAL)


add_lit_testsuite(check-llvm-spirv "Running the LLVM-SPIRV regression tests"
  ${CMAKE_CURRENT_BINARY_DIR}
  ARGS
    --verbose
  DEPENDS
    ${LLVM_SPIRV_TEST_DEPS}
    llvm-spirv
)

# to enable a custom test target on cmake below 3.11
# starting with 3.11 "test" is only reserved if ENABLE_TESTING(ON)
if(BUILD_EXTERNAL)
  cmake_policy(PUSH)
  if(POLICY CMP0037 AND ${CMAKE_VERSION} VERSION_LESS "3.11.0")
    cmake_policy(SET CMP0037 OLD)
  endif(POLICY CMP0037 AND ${CMAKE_VERSION} VERSION_LESS "3.11.0")
  add_custom_target(test
    DEPENDS
      check-llvm-spirv
  )
  cmake_policy(POP)
endif(BUILD_EXTERNAL)

=== lib/SPIRV/CMakeLists.txt ===
option(SPIRV_USE_LLVM_API "Enable usage of LLVM API for libSPIRV." ON)
if(SPIRV_USE_LLVM_API)
  add_definitions(-D_SPIRV_LLVM_API)
endif(SPIRV_USE_LLVM_API)

add_llvm_library(LLVMSPIRVLib
  LLVMToSPIRVDbgTran.cpp
  Mangler/FunctionDescriptor.cpp
  Mangler/Mangler.cpp
  Mangler/ManglingUtils.cpp
  Mangler/ParameterType.cpp
  OCL20To12.cpp
  OCL20ToSPIRV.cpp
  OCL21ToSPIRV.cpp
  OCLTypeToSPIRV.cpp
  OCLUtil.cpp
  SPIRVLowerBool.cpp
  SPIRVLowerConstExpr.cpp
  SPIRVLowerMemmove.cpp
  SPIRVLowerOCLBlocks.cpp
  SPIRVLowerSPIRBlocks.cpp
  SPIRVReader.cpp
  SPIRVRegularizeLLVM.cpp
  SPIRVToLLVMDbgTran.cpp
  SPIRVToOCL20.cpp
  SPIRVUtil.cpp
  SPIRVWriter.cpp
  SPIRVWriterPass.cpp
  TransOCLMD.cpp
  libSPIRV/SPIRVBasicBlock.cpp
  libSPIRV/SPIRVDebug.cpp
  libSPIRV/SPIRVDecorate.cpp
  libSPIRV/SPIRVEntry.cpp
  libSPIRV/SPIRVFunction.cpp
  libSPIRV/SPIRVInstruction.cpp
  libSPIRV/SPIRVModule.cpp
  libSPIRV/SPIRVStream.cpp
  libSPIRV/SPIRVType.cpp
  libSPIRV/SPIRVValue.cpp
  LINK_COMPONENTS
    Analysis
    BitWriter
    Core
    Support
    TransformUtils
  DEPENDS
    intrinsics_gen
)

target_include_directories(LLVMSPIRVLib
  PRIVATE
    ${LLVM_INCLUDE_DIR}
    ${LLVM_SPIRV_INCLUDE_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/libSPIRV
    ${CMAKE_CURRENT_SOURCE_DIR}/Mangler
)

=== tools/llvm-spirv/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS
  SPIRVLib
  Analysis
  BitReader
  BitWriter
  Core
  Support
  TransformUtils
)

add_llvm_tool(llvm-spirv
  llvm-spirv.cpp
  # llvm_setup_rpath messes with the rpath making llvm-spirv not executable from the build directory
  NO_INSTALL_RPATH
)

if (BUILD_EXTERNAL)
  target_link_libraries(llvm-spirv PRIVATE LLVMSPIRVLib)
endif()

target_include_directories(llvm-spirv
  PRIVATE
    ${LLVM_INCLUDE_DIR}
    ${LLVM_SPIRV_INCLUDE_DIRS}
)

=== debian/changelog ===
spirv-llvm-translator (8.0.0-3) experimental; urgency=medium

  * rules: Rebuild the archive index after stripping.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 15 Mar 2019 09:23:42 +0200

spirv-llvm-translator (8.0.0-2) experimental; urgency=medium

  * rules: Build with -fPIC.
  * rules: Strip the library.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 14 Mar 2019 23:53:32 +0200

spirv-llvm-translator (8.0.0-1) experimental; urgency=medium

  * Initial release (Closes: #921422)

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 06 Feb 2019 01:40:18 +0200

=== debian/control ===
Source: spirv-llvm-translator
Section: libdevel
Priority: optional
Maintainer: Debian OpenCL team <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders: Timo Aaltonen <tjaalton@debian.org>
Build-Depends: debhelper (>= 11),
 cmake,
 llvm-8-dev,
Standards-Version: 4.3.0
Homepage: https://github.com/KhronosGroup/SPIRV-LLVM-Translator
Vcs-Browser: https://salsa.debian.org/opencl-team/spirv-llvm-translator
Vcs-Git: https://salsa.debian.org/opencl-team/spirv-llvm-translator.git

Package: libllvmspirvlib-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: bi-directional translator for LLVM/SPIRV
 SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
 package includes a library and a tool for translation between LLVM IR
 and SPIR-V.
 .
 This package includes static libs and headers for development.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --builddir build/

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_CXX_FLAGS="-fPIC"

override_dh_auto_build:
	dh_auto_build
	(cd build; make llvm-spirv)

	strip build/lib/SPIRV/lib*
	ar -s build/lib/SPIRV/lib*

gentarball:
	tar --transform 's,^,$(DEB_SOURCE)-$(DEB_VERSION_UPSTREAM)/,' \
		--exclude 'debian' --exclude-vcs \
		-cJf ../$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM).orig.tar.xz .

## spirv-llvm-translator 8.0.0+git20190314

=== lib/SPIRV/CMakeLists.txt ===
--- 
+++ 
@@ -49,7 +49,7 @@
 
 target_include_directories(LLVMSPIRVLib
   PRIVATE
-    ${LLVM_INCLUDE_DIR}
+    ${LLVM_INCLUDE_DIRS}
     ${LLVM_SPIRV_INCLUDE_DIRS}
     ${CMAKE_CURRENT_SOURCE_DIR}
     ${CMAKE_CURRENT_SOURCE_DIR}/libSPIRV

=== debian/changelog ===
spirv-llvm-translator (8.0.0+git20190314-0ubuntu1) disco; urgency=medium

  * Upload to ubuntu.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 28 Mar 2019 09:37:49 +0200

spirv-llvm-translator (8.0.0+git20190314-1) experimental; urgency=medium

  * New upstream snapshot.
  * Build a shared library.
  * Package llvm-spirv.
  * Add patch to support clang block syntax.
  * rules: Drop rpath.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 20 Mar 2019 17:24:46 +0200

=== debian/rules ===
--- 
+++ 
@@ -7,14 +7,15 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-		-DCMAKE_CXX_FLAGS="-fPIC"
+		-DCMAKE_SKIP_RPATH=ON \
+		-DBUILD_SHARED_LIBS=ON
 
 override_dh_auto_build:
 	dh_auto_build
 	(cd build; make llvm-spirv)
 
-	strip build/lib/SPIRV/lib*
-	ar -s build/lib/SPIRV/lib*
+override_dh_missing:
+	dh_missing --fail-missing
 
 gentarball:
 	tar --transform 's,^,$(DEB_SOURCE)-$(DEB_VERSION_UPSTREAM)/,' \

## spirv-llvm-translator 8.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3)

set(LLVM_SPIRV_VERSION 0.2.1.0)

# check if we build inside llvm or not
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  set(BUILD_EXTERNAL YES)
  project(LLVM_SPIRV
    VERSION
      ${LLVM_SPIRV_VERSION}
    LANGUAGES
      CXX
  )

  set(CMAKE_CXX_STANDARD 11)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)

  if(LLVM_INCLUDE_TESTS)
    set(LLVM_TEST_COMPONENTS
      llvm-as
      llvm-dis
    )
  endif(LLVM_INCLUDE_TESTS)

  find_package(LLVM 8.0.0 REQUIRED
    COMPONENTS
      Analysis
      BitReader
      BitWriter
      Core
      Support
      TransformUtils
      ${LLVM_TEST_COMPONENTS}
  )
  set(CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH}
    ${LLVM_CMAKE_DIR}
  )
  include(AddLLVM)

  message(STATUS "Found LLVM: ${LLVM_VERSION}")
else(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  set(BUILD_EXTERNAL NO)
endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)

if(BUILD_EXTERNAL)
  find_program(CCACHE_EXE_FOUND ccache)
  if(CCACHE_EXE_FOUND)
    message(STATUS "Found ccache: ${CCACHE_EXE_FOUND}")
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
  endif()
endif()

set(LLVM_SPIRV_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/include)

add_subdirectory(lib/SPIRV)
add_subdirectory(tools/llvm-spirv)
if(LLVM_INCLUDE_TESTS)
  add_subdirectory(test)
endif(LLVM_INCLUDE_TESTS)

install(
  FILES
    ${LLVM_SPIRV_INCLUDE_DIRS}/LLVMSPIRVLib.h
  DESTINATION
    ${CMAKE_INSTALL_PREFIX}/include/LLVMSPIRVLib
)

configure_file(LLVMSPIRVLib.pc.in ${CMAKE_BINARY_DIR}/LLVMSPIRVLib.pc @ONLY)
install(
  FILES
    ${CMAKE_BINARY_DIR}/LLVMSPIRVLib.pc
  DESTINATION
    ${CMAKE_INSTALL_PREFIX}/lib${LLVM_LIBDIR_SUFFIX}/pkgconfig
)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,7 @@
     FileCheck
     count
     llvm-as
+    llvm-config
     llvm-dis
     not
   )
@@ -23,6 +24,7 @@
       llc
       llvm-dwarfdump
       llvm-objdump
+      llvm-readelf
       llvm-readobj
     )
   endif(NOT SKIP_SPIRV_DEBUG_INFO_TESTS)

=== lib/SPIRV/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,6 @@
   Mangler/Mangler.cpp
   Mangler/ManglingUtils.cpp
   Mangler/ParameterType.cpp
-  OCL20To12.cpp
   OCL20ToSPIRV.cpp
   OCL21ToSPIRV.cpp
   OCLTypeToSPIRV.cpp
@@ -22,6 +21,8 @@
   SPIRVReader.cpp
   SPIRVRegularizeLLVM.cpp
   SPIRVToLLVMDbgTran.cpp
+  SPIRVToOCL.cpp
+  SPIRVToOCL12.cpp
   SPIRVToOCL20.cpp
   SPIRVUtil.cpp
   SPIRVWriter.cpp

=== tools/llvm-spirv/Makefile ===
##===- tools/llvm-as/Makefile ------------------------------*- Makefile -*-===##
# 
#                     The LLVM Compiler Infrastructure
#
# This file is distributed under the University of Illinois Open Source
# License. See LICENSE.TXT for details.
# 
##===----------------------------------------------------------------------===##

LEVEL := ../..
TOOLNAME := llvm-spirv
LINK_COMPONENTS := analysis bitwriter bitreader spirv

# This tool has no plugins, optimize startup time.
TOOL_NO_EXPORTS := 1

include $(LEVEL)/Makefile.common

=== debian/changelog ===
spirv-llvm-translator (8.0.1-0ubuntu1) eoan; urgency=medium

  * release to eoan.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 01 Aug 2019 10:52:34 +0300

spirv-llvm-translator (8.0.1-1) unstable; urgency=medium

  * New upstream release.
  * rules: Set build type as 'Release'.
  * debian/patches: Refreshed.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 01 Aug 2019 10:06:44 +0300

=== debian/control ===
--- 
+++ 
@@ -11,12 +11,39 @@
 Vcs-Browser: https://salsa.debian.org/opencl-team/spirv-llvm-translator
 Vcs-Git: https://salsa.debian.org/opencl-team/spirv-llvm-translator.git
 
+Package: libllvmspirvlib8
+Architecture: any
+Depends:
+ ${shlibs:Depends},
+ ${misc:Depends}
+Description: bi-directional translator for LLVM/SPIRV -- shared library
+ SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
+ package includes a library and a tool for translation between LLVM IR
+ and SPIR-V.
+ .
+ This package includes the shared library.
+
 Package: libllvmspirvlib-dev
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends:
+ libllvmspirvlib8 (= ${binary:Version}),
+ ${misc:Depends}
+Description: bi-directional translator for LLVM/SPIRV -- development files
+ SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
+ package includes a library and a tool for translation between LLVM IR
+ and SPIR-V.
+ .
+ This package includes static libs and headers for development.
+
+Package: llvm-spirv
+Architecture: any
+Depends:
+ libllvmspirvlib8 (= ${binary:Version}),
+ ${shlibs:Depends},
+ ${misc:Depends}
 Description: bi-directional translator for LLVM/SPIRV
  SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
  package includes a library and a tool for translation between LLVM IR
  and SPIR-V.
  .
- This package includes static libs and headers for development.
+ This package includes the llvm-spirv binary.

## spirv-llvm-translator 9.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.3)
 
-set(LLVM_SPIRV_VERSION 0.2.1.0)
+set(LLVM_SPIRV_VERSION 9.0.0.1)
 
 # check if we build inside llvm or not
 if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
@@ -22,7 +22,7 @@
     )
   endif(LLVM_INCLUDE_TESTS)
 
-  find_package(LLVM 8.0.0 REQUIRED
+  find_package(LLVM 9.0.0 REQUIRED
     COMPONENTS
       Analysis
       BitReader
@@ -63,6 +63,8 @@
 install(
   FILES
     ${LLVM_SPIRV_INCLUDE_DIRS}/LLVMSPIRVLib.h
+    ${LLVM_SPIRV_INCLUDE_DIRS}/LLVMSPIRVOpts.h
+    ${LLVM_SPIRV_INCLUDE_DIRS}/LLVMSPIRVExtensions.inc
   DESTINATION
     ${CMAKE_INSTALL_PREFIX}/include/LLVMSPIRVLib
 )

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,38 @@
-llvm_canonicalize_cmake_booleans(SKIP_SPIRV_DEBUG_INFO_TESTS)
+include(FindPkgConfig)
+
+llvm_canonicalize_cmake_booleans(SPIRV_SKIP_CLANG_BUILD)
+llvm_canonicalize_cmake_booleans(SPIRV_SKIP_DEBUG_INFO_TESTS)
 
 # required by lit.site.cfg.py.in
 get_target_property(LLVM_SPIRV_DIR llvm-spirv BINARY_DIR)
 set(LLVM_SPIRV_TEST_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
+
+# find spirv-val
+pkg_search_module(SPIRV_TOOLS SPIRV-Tools)
+if(SPIRV_TOOLS_FOUND)
+  find_program(SPIRV_TOOLS_SPIRV_AS NAMES spirv-as PATHS ${SPIRV_TOOLS_PREFIX}/bin)
+  if(SPIRV_TOOLS_SPIRV_AS)
+    set(SPIRV_TOOLS_SPIRV_AS_FOUND True)
+  endif()
+
+  find_program(SPIRV_TOOLS_SPIRV_VAL NAMES spirv-val PATHS ${SPIRV_TOOLS_PREFIX}/bin)
+  if(SPIRV_TOOLS_SPIRV_VAL)
+    set(SPIRV_TOOLS_SPIRV_VAL_FOUND True)
+  endif()
+
+  set(SPIRV_TOOLS_BINDIR "${SPIRV_TOOLS_PREFIX}/bin")
+endif()
+
+if(NOT SPIRV_TOOLS_SPIRV_AS)
+  message(WARNING "spirv-as not found! SPIR-V assembly tests will not be run.")
+  set(SPIRV_TOOLS_SPIRV_AS_FOUND False)
+endif()
+
+if(NOT SPIRV_TOOLS_SPIRV_VAL)
+  message(WARNING "spirv-val not found! SPIR-V generated for test suite will not be validated.")
+  set(SPIRV_TOOLS_SPIRV_VAL_FOUND False)
+endif()
+
 configure_lit_site_cfg(
   ${CMAKE_CURRENT_SOURCE_DIR}/lit.site.cfg.py.in
   ${CMAKE_CURRENT_BINARY_DIR}/lit.site.cfg.py
@@ -19,7 +49,12 @@
     llvm-dis
     not
   )
-  if(NOT SKIP_SPIRV_DEBUG_INFO_TESTS)
+  if(NOT SPIRV_SKIP_CLANG_BUILD)
+    list(APPEND LLVM_SPIRV_TEST_DEPS
+      clang
+    )
+  endif(NOT SPIRV_SKIP_CLANG_BUILD)
+  if(NOT SPIRV_SKIP_DEBUG_INFO_TESTS)
     list(APPEND LLVM_SPIRV_TEST_DEPS
       llc
       llvm-dwarfdump
@@ -27,7 +62,7 @@
       llvm-readelf
       llvm-readobj
     )
-  endif(NOT SKIP_SPIRV_DEBUG_INFO_TESTS)
+  endif(NOT SPIRV_SKIP_DEBUG_INFO_TESTS)
 endif(NOT BUILD_EXTERNAL)

=== tools/llvm-spirv/CMakeLists.txt ===
--- 
+++ 
@@ -20,6 +20,6 @@
 
 target_include_directories(llvm-spirv
   PRIVATE
-    ${LLVM_INCLUDE_DIR}
+    ${LLVM_INCLUDE_DIRS}
     ${LLVM_SPIRV_INCLUDE_DIRS}
 )

=== debian/changelog ===
spirv-llvm-translator (9.0.0-0ubuntu1) eoan; urgency=medium

  * Upload to eoan.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 25 Sep 2019 10:26:23 +0300

spirv-llvm-translator (9.0.0-1) unstable; urgency=medium

  * New upstream release.
  * d/copyright: spirv.hpp is Expat.
  * Build with llvm-9.
  * patches: Dropped the only patch, applied upstream.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 24 Sep 2019 12:04:15 +0300

=== debian/control ===
--- 
+++ 
@@ -5,13 +5,15 @@
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper (>= 11),
  cmake,
- llvm-8-dev,
+ libclang-9-dev,
+ lldb-9,
+ llvm-9-dev,
 Standards-Version: 4.3.0
 Homepage: https://github.com/KhronosGroup/SPIRV-LLVM-Translator
 Vcs-Browser: https://salsa.debian.org/opencl-team/spirv-llvm-translator
 Vcs-Git: https://salsa.debian.org/opencl-team/spirv-llvm-translator.git
 
-Package: libllvmspirvlib8
+Package: libllvmspirvlib9
 Architecture: any
 Depends:
  ${shlibs:Depends},
@@ -26,7 +28,7 @@
 Package: libllvmspirvlib-dev
 Architecture: any
 Depends:
- libllvmspirvlib8 (= ${binary:Version}),
+ libllvmspirvlib9 (= ${binary:Version}),
  ${misc:Depends}
 Description: bi-directional translator for LLVM/SPIRV -- development files
  SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
@@ -38,7 +40,7 @@
 Package: llvm-spirv
 Architecture: any
 Depends:
- libllvmspirvlib8 (= ${binary:Version}),
+ libllvmspirvlib9 (= ${binary:Version}),
  ${shlibs:Depends},
  ${misc:Depends}
 Description: bi-directional translator for LLVM/SPIRV

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)-1\.tar\.gz%spirv-llvm-translator-$1.tar.gz%" \
   https://github.com/KhronosGroup/SPIRV-LLVM-Translator/tags \
   (?:.*?/)?v?(\d[\d.]*)-1\.tar\.gz

## spirv-llvm-translator 10.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,19 @@
 cmake_minimum_required(VERSION 3.3)
 
-set(LLVM_SPIRV_VERSION 9.0.0.1)
+set(LLVM_SPIRV_VERSION 10.0.0.1)
 
-# check if we build inside llvm or not
-if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
-  set(BUILD_EXTERNAL YES)
+option(LLVM_SPIRV_INCLUDE_TESTS
+  "Generate build targets for the llvm-spirv lit tests."
+  ${LLVM_INCLUDE_TESTS})
+
+if (NOT DEFINED LLVM_SPIRV_BUILD_EXTERNAL)
+  # check if we build inside llvm or not
+  if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
+    set(LLVM_SPIRV_BUILD_EXTERNAL YES)
+  endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
+endif (NOT DEFINED LLVM_SPIRV_BUILD_EXTERNAL)
+
+if(LLVM_SPIRV_BUILD_EXTERNAL)
   project(LLVM_SPIRV
     VERSION
       ${LLVM_SPIRV_VERSION}
@@ -12,17 +21,17 @@
       CXX
   )
 
-  set(CMAKE_CXX_STANDARD 11)
+  set(CMAKE_CXX_STANDARD 14)
   set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
-  if(LLVM_INCLUDE_TESTS)
+  if(LLVM_SPIRV_INCLUDE_TESTS)
     set(LLVM_TEST_COMPONENTS
       llvm-as
       llvm-dis
     )
-  endif(LLVM_INCLUDE_TESTS)
+  endif(LLVM_SPIRV_INCLUDE_TESTS)
 
-  find_package(LLVM 9.0.0 REQUIRED
+  find_package(LLVM 10.0.0 REQUIRED
     COMPONENTS
       Analysis
       BitReader
@@ -39,11 +48,7 @@
   include(AddLLVM)
 
   message(STATUS "Found LLVM: ${LLVM_VERSION}")
-else(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
-  set(BUILD_EXTERNAL NO)
-endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
 
-if(BUILD_EXTERNAL)
   find_program(CCACHE_EXE_FOUND ccache)
   if(CCACHE_EXE_FOUND)
     message(STATUS "Found ccache: ${CCACHE_EXE_FOUND}")
@@ -56,9 +61,9 @@
 
 add_subdirectory(lib/SPIRV)
 add_subdirectory(tools/llvm-spirv)
-if(LLVM_INCLUDE_TESTS)
+if(LLVM_SPIRV_INCLUDE_TESTS)
   add_subdirectory(test)
-endif(LLVM_INCLUDE_TESTS)
+endif(LLVM_SPIRV_INCLUDE_TESTS)
 
 install(
   FILES

=== lib/SPIRV/CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,3 @@
-option(SPIRV_USE_LLVM_API "Enable usage of LLVM API for libSPIRV." ON)
-if(SPIRV_USE_LLVM_API)
-  add_definitions(-D_SPIRV_LLVM_API)
-endif(SPIRV_USE_LLVM_API)
-
 add_llvm_library(LLVMSPIRVLib
   LLVMToSPIRVDbgTran.cpp
   Mangler/FunctionDescriptor.cpp
@@ -27,7 +22,7 @@
   SPIRVUtil.cpp
   SPIRVWriter.cpp
   SPIRVWriterPass.cpp
-  TransOCLMD.cpp
+  PreprocessMetadata.cpp
   libSPIRV/SPIRVBasicBlock.cpp
   libSPIRV/SPIRVDebug.cpp
   libSPIRV/SPIRVDecorate.cpp

=== tools/llvm-spirv/CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,7 @@
   NO_INSTALL_RPATH
 )
 
-if (BUILD_EXTERNAL)
+if (LLVM_SPIRV_BUILD_EXTERNAL)
   target_link_libraries(llvm-spirv PRIVATE LLVMSPIRVLib)
 endif()

=== debian/changelog ===
spirv-llvm-translator (10.0.0-1) unstable; urgency=medium

  * New upstream release.
  * watch: Updated.
  * Build against llvm-10.
  * control: Use debhelper-compat, bump to 12.
  * control: Bump policy to 4.5.0.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 01 Apr 2020 20:44:04 +0300

=== debian/control ===
--- 
+++ 
@@ -3,17 +3,17 @@
 Priority: optional
 Maintainer: Debian OpenCL team <pkg-opencl-devel@lists.alioth.debian.org>
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 12),
  cmake,
- libclang-9-dev,
- lldb-9,
- llvm-9-dev,
-Standards-Version: 4.3.0
+ libclang-10-dev,
+ lldb-10,
+ llvm-10-dev,
+Standards-Version: 4.5.0
 Homepage: https://github.com/KhronosGroup/SPIRV-LLVM-Translator
 Vcs-Browser: https://salsa.debian.org/opencl-team/spirv-llvm-translator
 Vcs-Git: https://salsa.debian.org/opencl-team/spirv-llvm-translator.git
 
-Package: libllvmspirvlib9
+Package: libllvmspirvlib10
 Architecture: any
 Depends:
  ${shlibs:Depends},
@@ -28,7 +28,7 @@
 Package: libllvmspirvlib-dev
 Architecture: any
 Depends:
- libllvmspirvlib9 (= ${binary:Version}),
+ libllvmspirvlib10 (= ${binary:Version}),
  ${misc:Depends}
 Description: bi-directional translator for LLVM/SPIRV -- development files
  SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
@@ -40,7 +40,7 @@
 Package: llvm-spirv
 Architecture: any
 Depends:
- libllvmspirvlib9 (= ${binary:Version}),
+ libllvmspirvlib10 (= ${binary:Version}),
  ${shlibs:Depends},
  ${misc:Depends}
 Description: bi-directional translator for LLVM/SPIRV

=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,7 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
+		-DCMAKE_BUILD_TYPE=Release \
 		-DCMAKE_SKIP_RPATH=ON \
 		-DBUILD_SHARED_LIBS=ON

## spirv-llvm-translator 11.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,7 @@
 cmake_minimum_required(VERSION 3.3)
 
-set(LLVM_SPIRV_VERSION 10.0.0.1)
+set (BASE_LLVM_VERSION 11.0.0)
+set(LLVM_SPIRV_VERSION ${BASE_LLVM_VERSION}.0)
 
 option(LLVM_SPIRV_INCLUDE_TESTS
   "Generate build targets for the llvm-spirv lit tests."
@@ -31,7 +32,7 @@
     )
   endif(LLVM_SPIRV_INCLUDE_TESTS)
 
-  find_package(LLVM 10.0.0 REQUIRED
+  find_package(LLVM ${BASE_LLVM_VERSION} REQUIRED
     COMPONENTS
       Analysis
       BitReader

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -40,7 +40,7 @@
     ${CMAKE_CURRENT_SOURCE_DIR}/lit.cfg.py
 )
 
-if(NOT BUILD_EXTERNAL)
+if(NOT LLVM_SPIRV_BUILD_EXTERNAL)
   set(LLVM_SPIRV_TEST_DEPS
     FileCheck
     count
@@ -63,7 +63,7 @@
       llvm-readobj
     )
   endif(NOT SPIRV_SKIP_DEBUG_INFO_TESTS)
-endif(NOT BUILD_EXTERNAL)
+endif(NOT LLVM_SPIRV_BUILD_EXTERNAL)
 
 
 add_lit_testsuite(check-llvm-spirv "Running the LLVM-SPIRV regression tests"
@@ -77,7 +77,7 @@
 
 # to enable a custom test target on cmake below 3.11
 # starting with 3.11 "test" is only reserved if ENABLE_TESTING(ON)
-if(BUILD_EXTERNAL)
+if(LLVM_SPIRV_BUILD_EXTERNAL)
   cmake_policy(PUSH)
   if(POLICY CMP0037 AND ${CMAKE_VERSION} VERSION_LESS "3.11.0")
     cmake_policy(SET CMP0037 OLD)
@@ -87,4 +87,4 @@
       check-llvm-spirv
   )
   cmake_policy(POP)
-endif(BUILD_EXTERNAL)
+endif(LLVM_SPIRV_BUILD_EXTERNAL)

=== lib/SPIRV/CMakeLists.txt ===
--- 
+++ 
@@ -8,10 +8,12 @@
   OCL21ToSPIRV.cpp
   OCLTypeToSPIRV.cpp
   OCLUtil.cpp
+  VectorComputeUtil.cpp
   SPIRVLowerBool.cpp
   SPIRVLowerConstExpr.cpp
   SPIRVLowerMemmove.cpp
   SPIRVLowerOCLBlocks.cpp
+  SPIRVLowerSaddWithOverflow.cpp
   SPIRVLowerSPIRBlocks.cpp
   SPIRVReader.cpp
   SPIRVRegularizeLLVM.cpp
@@ -37,6 +39,8 @@
     Analysis
     BitWriter
     Core
+    IRReader
+    Linker
     Support
     TransformUtils
   DEPENDS

=== debian/changelog ===
spirv-llvm-translator (11.0.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Mark -dev as M-A: same.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 20 Oct 2020 11:24:57 +0300

spirv-llvm-translator (11.0~git20200922-1) unstable; urgency=medium

  * New upstream snapshot.
  * Build against llvm-11.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 22 Sep 2020 19:45:26 +0300

=== debian/control ===
--- 
+++ 
@@ -5,15 +5,15 @@
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper-compat (= 12),
  cmake,
- libclang-10-dev,
- lldb-10,
- llvm-10-dev,
+ libclang-11-dev,
+ lldb-11,
+ llvm-11-dev,
 Standards-Version: 4.5.0
 Homepage: https://github.com/KhronosGroup/SPIRV-LLVM-Translator
 Vcs-Browser: https://salsa.debian.org/opencl-team/spirv-llvm-translator
 Vcs-Git: https://salsa.debian.org/opencl-team/spirv-llvm-translator.git
 
-Package: libllvmspirvlib10
+Package: libllvmspirvlib11
 Architecture: any
 Depends:
  ${shlibs:Depends},
@@ -28,8 +28,9 @@
 Package: libllvmspirvlib-dev
 Architecture: any
 Depends:
- libllvmspirvlib10 (= ${binary:Version}),
+ libllvmspirvlib11 (= ${binary:Version}),
  ${misc:Depends}
+Multi-Arch: same
 Description: bi-directional translator for LLVM/SPIRV -- development files
  SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
  package includes a library and a tool for translation between LLVM IR
@@ -40,7 +41,7 @@
 Package: llvm-spirv
 Architecture: any
 Depends:
- libllvmspirvlib10 (= ${binary:Version}),
+ libllvmspirvlib11 (= ${binary:Version}),
  ${shlibs:Depends},
  ${misc:Depends}
 Description: bi-directional translator for LLVM/SPIRV

## spirv-llvm-translator 12.0.0

=== debian/changelog ===
spirv-llvm-translator (12.0.0-1) experimental; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 07 Jun 2021 12:24:54 +0300

spirv-llvm-translator (12.0~git20210212-2) experimental; urgency=medium

  * control: Fix libllvmspirvlib-dev depends.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 10 May 2021 12:17:08 +0300

spirv-llvm-translator (12.0~git20210212-1) experimental; urgency=medium

  * New upstream snapshot.
  * Build against llvm-12.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 12 Apr 2021 20:24:01 +0300

=== debian/control ===
--- 
+++ 
@@ -5,15 +5,15 @@
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper-compat (= 12),
  cmake,
- libclang-11-dev,
- lldb-11,
- llvm-11-dev,
+ libclang-12-dev,
+ lldb-12,
+ llvm-12-dev,
 Standards-Version: 4.5.0
 Homepage: https://github.com/KhronosGroup/SPIRV-LLVM-Translator
 Vcs-Browser: https://salsa.debian.org/opencl-team/spirv-llvm-translator
 Vcs-Git: https://salsa.debian.org/opencl-team/spirv-llvm-translator.git
 
-Package: libllvmspirvlib11
+Package: libllvmspirvlib12
 Architecture: any
 Depends:
  ${shlibs:Depends},
@@ -28,7 +28,7 @@
 Package: libllvmspirvlib-dev
 Architecture: any
 Depends:
- libllvmspirvlib11 (= ${binary:Version}),
+ libllvmspirvlib12 (= ${binary:Version}),
  ${misc:Depends}
 Multi-Arch: same
 Description: bi-directional translator for LLVM/SPIRV -- development files
@@ -41,7 +41,7 @@
 Package: llvm-spirv
 Architecture: any
 Depends:
- libllvmspirvlib11 (= ${binary:Version}),
+ libllvmspirvlib12 (= ${binary:Version}),
  ${shlibs:Depends},
  ${misc:Depends}
 Description: bi-directional translator for LLVM/SPIRV

## spirv-llvm-translator 13.0~git20210929

=== debian/changelog ===
spirv-llvm-translator (13.0~git20210929-1) unstable; urgency=medium

  * New upstream snapshot.
  * Build with llvm 13.
  * Add spirv-headers to build-depends, set headers dir.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 29 Sep 2021 14:40:45 +0300

spirv-llvm-translator (12.0.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 16 Aug 2021 09:59:48 +0300

=== debian/control ===
--- 
+++ 
@@ -5,15 +5,16 @@
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper-compat (= 12),
  cmake,
- libclang-12-dev,
- lldb-12,
- llvm-12-dev,
+ libclang-13-dev,
+ lldb-13,
+ llvm-13-dev,
+ spirv-headers,
 Standards-Version: 4.5.0
 Homepage: https://github.com/KhronosGroup/SPIRV-LLVM-Translator
 Vcs-Browser: https://salsa.debian.org/opencl-team/spirv-llvm-translator
 Vcs-Git: https://salsa.debian.org/opencl-team/spirv-llvm-translator.git
 
-Package: libllvmspirvlib12
+Package: libllvmspirvlib13
 Architecture: any
 Depends:
  ${shlibs:Depends},
@@ -28,7 +29,7 @@
 Package: libllvmspirvlib-dev
 Architecture: any
 Depends:
- libllvmspirvlib12 (= ${binary:Version}),
+ libllvmspirvlib13 (= ${binary:Version}),
  ${misc:Depends}
 Multi-Arch: same
 Description: bi-directional translator for LLVM/SPIRV -- development files
@@ -41,7 +42,7 @@
 Package: llvm-spirv
 Architecture: any
 Depends:
- libllvmspirvlib12 (= ${binary:Version}),
+ libllvmspirvlib13 (= ${binary:Version}),
  ${shlibs:Depends},
  ${misc:Depends}
 Description: bi-directional translator for LLVM/SPIRV

=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,7 @@
 	dh_auto_configure -- \
 		-DCMAKE_BUILD_TYPE=Release \
 		-DCMAKE_SKIP_RPATH=ON \
+		-DLLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR=/usr/include \
 		-DBUILD_SHARED_LIBS=ON
 
 override_dh_auto_build:

## spirv-llvm-translator 13.0.0

=== tools/llvm-spirv/CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,7 @@
   NO_INSTALL_RPATH
 )
 
-if (LLVM_SPIRV_BUILD_EXTERNAL)
+if (LLVM_SPIRV_BUILD_EXTERNAL OR LLVM_LINK_LLVM_DYLIB)
   target_link_libraries(llvm-spirv PRIVATE LLVMSPIRVLib)
 endif()

=== debian/changelog ===
spirv-llvm-translator (13.0.0-4) unstable; urgency=medium

  * Rename /usr/bin/llvm-spirv to /usr/bin/llvm-spirv-13.
  * Restrict watch file to 13.* releases.
  * Enable all hardening flags.
  * Bump Standards-Version to 4.6.1.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 16 May 2022 01:58:34 +0200

spirv-llvm-translator (13.0.0-3) unstable; urgency=medium

  * Rename OpConstFunctionPointerINTEL to OpConstantFunctionPointerINTEL to
    fix FTBFS with spirv-headers 1.5.5.  (Closes: #1005458)
  * rules: Parse llvm version from Build-Depends.
  * control: Provide virtual package libllvmspirvlib-13-dev.
  * control: Set Rules-Requires-Root: no.
  * control, install: Multiarchify the packages.
  * upstream/metadata: Add.
  * copyright: Update/remove outdated file patterns.
  * Fix typo.
  * Update Lintian overrides.
  * Add myself to Uploaders.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 16 Feb 2022 23:28:24 +0100

spirv-llvm-translator (13.0.0-2) unstable; urgency=medium

  * control: Drop lldb-13 from build-depends, it's not used and prevents
    build on mips/mipsel.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 17 Nov 2021 11:00:43 +0200

spirv-llvm-translator (13.0.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump debhelper to 13.
  * control: Bump policy to 4.6.0.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 27 Oct 2021 10:41:14 +0300

spirv-llvm-translator-12 (12.0.0-4) unstable; urgency=medium

  * Restrict watch file to 12.* releases.
  * Enable all hardening flags.
  * Bump Standards-Version to 4.6.1.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 15 May 2022 23:58:08 +0200

spirv-llvm-translator-12 (12.0.0-3) unstable; urgency=medium

  [ Timo Aaltonen ]
  * control: Bump debhelper to 13.
  * control: Bump policy to 4.6.0.
  * control: Drop lldb-12 from build-depends, it's not used and prevents
    build on mips/mipsel.

  [ Andreas Beckmann ]
  * rules: Parse llvm version from Build-Depends.
  * control: Set Rules-Requires-Root: no.
  * control, install: Multiarchify the packages.
  * upstream/metadata: Add.
  * copyright: Update/remove outdated file patterns.
  * Fix typo.
  * Update Lintian overrides.
  * Add myself to Uploaders.
  * Have one set of packages per llvm version:
    - Fork source package as spirv-llvm-translator-12.
    - Rename binary packages:
      + libllvmspirvlib-dev => libllvmspirvlib-12-dev,
      + llvm-spirv => llvm-spirv-12.
    - Rename /usr/bin/llvm-spirv to /usr/bin/llvm-spirv-12.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 09 Feb 2022 20:05:39 +0100

spirv-llvm-translator-11 (11.0.0-2) unstable; urgency=medium

  [ Timo Aaltonen ]
  * control: Bump debhelper to 13.
  * control: Bump policy to 4.6.0.
  * control: Drop lldb-11 from build-depends, it's not used and prevents
    build on mips/mipsel.

  [ Andreas Beckmann ]
  * rules: Parse llvm version from Build-Depends.
  * control: Set Rules-Requires-Root: no.
  * control, install: Multiarchify the packages.
  * upstream/metadata: Add.
  * copyright: Update/remove outdated file patterns.
  * Fix typo.
  * Update Lintian overrides.
  * Add myself to Uploaders.
  * Have one set of packages per llvm version:
    - Fork source package as spirv-llvm-translator-11.
    - Rename binary packages:
      + libllvmspirvlib-dev => libllvmspirvlib-11-dev,
      + llvm-spirv => llvm-spirv-11.
    - Rename /usr/bin/llvm-spirv to /usr/bin/llvm-spirv-11.
  * Allow overriding BASE_LLVM_VERSION.
  * Restrict watch file to 11.* releases.
  * Enable all hardening flags.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 11 Apr 2022 10:32:52 +0200

=== debian/control ===
--- 
+++ 
@@ -2,20 +2,24 @@
 Section: libdevel
 Priority: optional
 Maintainer: Debian OpenCL team <pkg-opencl-devel@lists.alioth.debian.org>
-Uploaders: Timo Aaltonen <tjaalton@debian.org>
-Build-Depends: debhelper-compat (= 12),
+Uploaders:
+ Timo Aaltonen <tjaalton@debian.org>,
+ Andreas Beckmann <anbe@debian.org>,
+Build-Depends: debhelper-compat (= 13),
  cmake,
  libclang-13-dev,
- lldb-13,
  llvm-13-dev,
- spirv-headers,
-Standards-Version: 4.5.0
+ spirv-headers (>= 1.5.5),
+Rules-Requires-Root: no
+Standards-Version: 4.6.1
 Homepage: https://github.com/KhronosGroup/SPIRV-LLVM-Translator
 Vcs-Browser: https://salsa.debian.org/opencl-team/spirv-llvm-translator
-Vcs-Git: https://salsa.debian.org/opencl-team/spirv-llvm-translator.git
+Vcs-Git: https://salsa.debian.org/opencl-team/spirv-llvm-translator.git -b llvm13/master
 
 Package: libllvmspirvlib13
 Architecture: any
+Multi-Arch: same
+Section: libs
 Depends:
  ${shlibs:Depends},
  ${misc:Depends}
@@ -28,10 +32,17 @@
 
 Package: libllvmspirvlib-dev
 Architecture: any
+Multi-Arch: same
 Depends:
  libllvmspirvlib13 (= ${binary:Version}),
  ${misc:Depends}
-Multi-Arch: same
+Conflicts:
+ libllvmspirvlib-x.y-dev,
+Replaces:
+ libllvmspirvlib-x.y-dev,
+Provides:
+ libllvmspirvlib-13-dev,
+ libllvmspirvlib-x.y-dev,
 Description: bi-directional translator for LLVM/SPIRV -- development files
  SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
  package includes a library and a tool for translation between LLVM IR
@@ -45,9 +56,11 @@
  libllvmspirvlib13 (= ${binary:Version}),
  ${shlibs:Depends},
  ${misc:Depends}
+Provides:
+ llvm-spirv-13,
 Description: bi-directional translator for LLVM/SPIRV
  SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
  package includes a library and a tool for translation between LLVM IR
  and SPIR-V.
  .
- This package includes the llvm-spirv binary.
+ This package includes the llvm-spirv-13 binary.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS	 = hardening=+all

include /usr/share/dpkg/pkg-info.mk

LLVM_VERSION	 = $(shell sed -n -r '/^Build/,/^$$/s/.*llvm-([0-9]+)-dev.*/\1/p' debian/control)

%:
	dh $@ --builddir build/

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_SKIP_RPATH=ON \
		-DLLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR=/usr/include \
		-DBUILD_SHARED_LIBS=ON \
		-Wno-dev

execute_after_dh_auto_build:
	$(MAKE) -C build llvm-spirv
	mv build/tools/llvm-spirv/llvm-spirv build/tools/llvm-spirv/llvm-spirv-$(LLVM_VERSION)

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%spirv-llvm-translator-$1.tar.gz%" \
   https://github.com/KhronosGroup/SPIRV-LLVM-Translator/tags \
   (?:.*?/)?v?(13\.[\d.]*)\.tar\.gz
